ORCA/M Asm65816 2.1.0

0001 4081                       title 'PictureDefProc -- Do_Dispose' 
0002 4081              ****************************************************************
0003 4081              *
0004 4081              do_Dispose PROC EXPORT 
0005 4081              *
0006 4081              * Inits fields in the control record based on the values in
0007 4081              * in the control template.
0008 4081              *
0009 4081              * The ctlData field is set to be a pointer to the static text
0010 4081              * and the ctlValue field is set to be the size of the static
0011 4081              * text field (from the value in the template).
0012 4081              *
0013 4081              *
0014 4081              * Inputs:
0015 4081              *                   ctlHandle
0016 4081              *                   ctlPtr
0017 4081              *                   ctlParam = ptr to template
0018 4081              *
0019 4081              * Outputs:
0020 4081              *                   a-reg and x-reg are zero.
0021 4081              *
0022 4081              * External Refs:
0023 4081                       import PushCtlData 
0024 4081              *
0025 4081              * Entry Points:
0026 4081              *                   none
0027 4081              *
0028 4081                       longa on                       ; mode
0029 4081                       longi on
0030 4081              *
0031 4081              * Change History
0032 4081              *
0033 4081              * 15 May 89         Steven Glass
0034 4081              *
0035 4081              * Added.
0036 4081              *
0037 4081              ****************************************************************
0038 4081
0039 4081
0040 4081 A0 3C 00              ldy   #NewCtlRecord.ctlMoreFlags
0041 4084 B7 04                 lda   [ctlPtr],y
0042 4086 29 03 00              and   #$0003                   ; only care about low 2 bits
0043 4089 C9 01 00              cmp   #1                       ;(RefIsHandle)      ; If not handle, it must be resource
0044 408C F0 0D                 beq   JustAHandle
0045 408E
0046 408E F4 02 80              PushWord #rPicture 
0047 4091 20 B3 33              jsr   PushCtlData
0048 4094 A2 10 33 22           _CMReleaseResource 
0049 409B
0050 409B              JustAHandle  
0051 409B
0052 409B A9 00 00              lda   #0
0053 409E AA                    tax   
0054 409F 60                    rts   
0055 40A0
0056 40A0
0057 40A0
0058 40A0                       ENDP 
