ORCA/M Asm65816 2.1.0

0001 6A6D              **********************************************************************
0002 6A6D              *
0003 6A6D              * Dialog Manager Version 3.3
0004 6A6D              *
0005 6A6D              * Copyright Apple Computer, Inc. 1986-1993
0006 6A6D              * All rights reserved.
0007 6A6D              *
0008 6A6D              *
0009 6A6D              * Originally by Jean-Charles Mourey
0010 6A6D              * Modified by Harry Yee
0011 6A6D              *
0012 6A6D              * The dialog manager is a tool that supports modal and modeless 
0013 6A6D              * dialogs.
0014 6A6D              *
0015 6A6D              * Files:
0016 6A6D              *    Special.Macros
0017 6A6D              *
0018 6A6D              * Modification History
0019 6A6D              *
0020 6A6D              * 17-Sep-90         Dave Lyons
0021 6A6D              *
0022 6A6D              * Removed dependency on all.macros.
0023 6A6D              * Crunched "pushlong <xxx" and "pushword <xxx" macros to pushlongdp and pushworddp.
0024 6A6D              * Optimizations (search for DAL).
0025 6A6D              * Version number $8304.
0026 6A6D              * This saved 362 bytes for ROM 1.
0027 6A6D              *
0028 6A6D              * 24-Sep-90         Dave Lyons
0029 6A6D              *
0030 6A6D              * Changed link and tlink macros to omit useless "sec sbc #0 tcs" after a tsc.
0031 6A6D              * Changed StdSoundProc to call SysBeep2 with $8000 for Alert stage 0,
0032 6A6D              * 1-3 for Alert stages 1-3, and 4 for clicking outside a dialog or alert.
0033 6A6D              *
0034 6A6D              * 17-Feb-91         Dave Lyons
0035 6A6D              *
0036 6A6D              * Changed StdSoundProc again to use the newly-defined bit 14 in SysBeep2, to
0037 6A6D              * defer the sound until the next GetNextEvent call.  Click-outside-dialog is
0038 6A6D              * not deferred, but the other ones are.
0039 6A6D              *
0040 6A6D              * 3-Mar-91          Dave Lyons
0041 6A6D              *
0042 6A6D              * Fixed a very old coding error after GetOldEditLine; it was checking the low
0043 6A6D              * word of a value twice instead of checking both words.  I don't think this
0044 6A6D              * had any actual consequences, but I fixed it anyway.
0045 6A6D              *
0046 6A6D              * 5-Mar-91          Dave Lyons
0047 6A6D              *
0048 6A6D              * Adding support for I-Beam cursors.  Set bit 30 of the ModalDialog or
0049 6A6D              * ModalDialog2 filter proc, and it calls InitCursor for you on the way in.
0050 6A6D              * Then it watches where the cursor is and calls InitCursor and IBeamCursor
0051 6A6D              * for you, and it resets the cursor to an arrow on the way out if
0052 6A6D              * necessary.
0053 6A6D              *
0054 6A6D              * 7-Mar-91          Dave Lyons
0055 6A6D              *
0056 6A6D              * Rewrote part of the I-Beam stuff.  Now uses FindCursorCtl instead of
0057 6A6D              * FindDItem, since FindDItem was actually forcing inactive edit line
0058 6A6D              * items to become active.
0059 6A6D              *
0060 6A6D              * Also, we only show an I-Beam over the an edit-line item with an
0061 6A6D              * *active* Line Edit record, not over all the edit line items.
0062 6A6D              *
0063 6A6D              * 4-Jun-91          Dave Lyons
0064 6A6D              *
0065 6A6D              * Adding conditional code to use colorful icons, instead of black-and-white
0066 6A6D              * ones (Note, Caution, Stop icons).  I need separate icons for 320 vs. 640.
0067 6A6D              *
0068 6A6D              * 10-Jun-91         Dave Lyons
0069 6A6D              *
0070 6A6D              * Removed check for an editLine item being active; we use the I-Beam cursor
0071 6A6D              * over even inactive ones now.
0072 6A6D              *
0073 6A6D              * Exported colored icons so the ROM 3 patch can use them.
0074 6A6D              *
0075 6A6D              * 26-Aug-91         Dave Lyons
0076 6A6D              *
0077 6A6D              * Added check in CreateIcon for dialog at odd X position.  If odd,
0078 6A6D              * we make the icon position (local coordinates) odd too, so the colors
0079 6A6D              * will be right.
0080 6A6D              *
0081 6A6D              * 13-Oct-91         Dave Lyons
0082 6A6D              *
0083 6A6D              * In 320 mode, NoteAlert, StopAlert, and CautionAlert were putting
0084 6A6D              * their icons at X=0 instead of X=20.  Oops, fixed.
0085 6A6D              *
0086 6A6D              * 5-Feb-92          Dave Lyons
0087 6A6D              *
0088 6A6D              * Version $0304.
0089 6A6D              *
0090 6A6D              **********************************************************************
0091 6A6D              *
0092 6A6D              * BEGIN 6.0.1
0093 6A6D              *
0094 6A6D              * 26-Jan-93         Dave Lyons
0095 6A6D              *
0096 6A6D              * Version $8305.  Removed a bogus DEY in Beep that was seeing the
0097 6A6D              * high byte of the DAFont and deciding that a NIL sound proc was
0098 6A6D              * actually non-nil, and calling it.  This was not a problem in ROM
0099 6A6D              * 3, because it was already patched so that the sound proc is
0100 6A6D              * always non-nil.
0101 6A6D              *
0102 6A6D              * 1-Apr-93          Steve Stephenson
0103 6A6D              *
0104 6A6D              * Version $0305 for 6.0.1 (final)
0105 6A6D              *
0106 6A6D              **********************************************************************
0107 6A6D
0108 6A6D
0109 6A6D
0110 6A6D              ;______________________________________________________________________________
0111 6A6D              ;
0112 6A6D              ;        DialogStartup
0113 6A6D              ;
0114 6A6D              ;       input: ProgramID:WORD - ID to use with the Memory Manager
0115 6A6D              ;
0116 6A6D              ;      output: none
0117 6A6D              ;
0118 6A6D              ; Change History
0119 6A6D              ;
0120 6A6D              ; 4 Mar 88          Steven Glass
0121 6A6D              ;
0122 6A6D              ; Modified code to use the WAP entry for this tool.  First, we check the
0123 6A6D              ; WAP to see if we are already active.  If we are already active, then we
0124 6A6D              ; return a new error code.  If we are not active, we get the control
0125 6A6D              ; manager's direct page and save it in our WAP.
0126 6A6D              ;
0127 6A6D              ; 19 May 89         Steven Glass
0128 6A6D              ;
0129 6A6D              ; Changed it again so that we don't check to see if we were already active.
0130 6A6D              ; The march 4 check that is in ROM, doesn't work.  Anyway, we found that 
0131 6A6D              ; applications were dieing if an error was returned anyway.
0132 6A6D              ;
0133 6A6D              ;______________________________________________________________________________
0134 6A6D
0135 6A6D                       ENTRY DialogStartup 
0136 6A6D
0137 6A6D              DialogStartup PROC Export 
0138 6A6D
0139 6A6D 3B 0B 1A 5B           tlink 2 
0140 6A71
0141 6A71              ProgramID equ   input
0142 6A71
0143 6A71              ;
0144 6A71              ; Save ProgramID on stack
0145 6A71              ;
0146 6A71 D4 06                 pei   <ProgramID
0147 6A73
0148 6A73
0149 6A73
0150 6A73              NotYetActive  
0151 6A73              ;
0152 6A73              ; Get Dialog Manager Zero Page
0153 6A73              ;
0154 6A73 48                    pha   
0155 6A74 A2 10 1F 22           _GetCtlDPage 
0156 6A7B 2B                    pld   
0157 6A7C
0158 6A7C              ;
0159 6A7C              ; Set Dialog Mgr's WAP
0160 6A7C              ;
0161 6A7C F4 00 00              PushWord #0 
0162 6A7F F4 15 00              PushWord #DlgTool 
0163 6A82 F4 00 00              PushWord #0 
0164 6A85 0B                    phd   
0165 6A86 A2 01 0D 22           _SetWAP 
0166 6A8D
0167 6A8D              ;-----------------------------------------------------------
0168 6A8D              ;
0169 6A8D              ; Now, using our part of the zero page, lets 
0170 6A8D              ; init our stuff.
0171 6A8D              ;
0172 6A8D 68                    pla                            ; save memory manager ID to use
0173 6A8E 85 82                 sta   <mmgrID
0174 6A90
0175 6A90 A9 48 23              lda   #DlgSig                  ; Set signature
0176 6A93 85 80                 sta   <Signature
0177 6A95
0178 6A95 A9 00 00 A2           zero #EndZeroPage-DialogFont,<DialogFont ; clear all other parms
0179 6AA1
0180 6AA1 48                    pha                            ; long space for result
0181 6AA2 48                    pha   
0182 6AA3 F4 00 00              pea   0                        ; get size of memory 
0183 6AA6 F4 62 00              pushword #98 
0184 6AA9 D4 82                 pei   mmgrID
0185 6AAB              ;
0186 6AAB              ; was:
0187 6AAB              ;	pushword #0	; no restrictions
0188 6AAB F4 00 40              pea   $4000                    ; allocate as fixed (non-moveable)
0189 6AAE                                                      ; cause we dereference it right away...
0190 6AAE 48                    pha   
0191 6AAF 48                    pha   
0192 6AB0 A2 02 09 22           _NewHandle 
0193 6AB7
0194 6AB7 68                    pla   
0195 6AB8 85 A2                 sta   <MemHandle
0196 6ABA 68                    pla   
0197 6ABB 85 A4                 sta   <MemHandle+2
0198 6ABD
0199 6ABD A7 A2                 lda   [<MemHandle]
0200 6ABF 85 A6                 sta   <WindowPointer
0201 6AC1 A0 02 00              ldy   #2
0202 6AC4 B7 A2                 lda   [<MemHandle],y
0203 6AC6 85 A8                 sta   <WindowPointer+2
0204 6AC8
0205 6AC8
0206 6AC8 A5 A6                 lda   <WindowPointer
0207 6ACA 18                    clc   
0208 6ACB 69 4E 00              adc   #78
0209 6ACE 85 AA                 sta   <HandStruct
0210 6AD0 A5 A8                 lda   <WindowPointer+2
0211 6AD2 69 00 00              adc   #0
0212 6AD5 85 AC                 sta   <HandStruct+2
0213 6AD7
0214 6AD7 A9 00 00              lda   #0000
0215 6ADA
0216 6ADA A2 00 00              ldx   #0                       ; accumulator is already 0
0217 6ADD 4C F0 72              jmp   quit2
0218 6AE0
0219 6AE0                       ENDP 
0220 6AE0
0221 6AE0
0222 6AE0
0223 6AE0                       TITLE 'Alert Procedures' 
0224 6AE0
0225 6AE0              ;..............................................
0226 6AE0              ;
0227 6AE0              ;        Alert Icon	Datas
0228 6AE0              ;
0229 6AE0              ;..............................................
0230 6AE0
0231 6AE0                       ENTRY AlertIconDatas 
0232 6AE0              AlertIconDatas PROC export 
0233 6AE0
0234 6AE0              ;   ENTRY  IconHandleStruct
0235 6AE0              ;IconHandleStruct	DS.B  20	    ; Fake Handle structure to icon
0236 6AE0
0237 6AE0                       export Icon320Table 
0238 6AE0 10 72 02 00  Icon320Table DC L:StopIcon320
0239 6AE4 74 70 02 00           DC L:NoteIcon320
0240 6AE8 54 71 02 00           DC L:CautionIcon320
0241 6AEC
0242 6AEC                       export Icon640Table 
0243 6AEC 94 6F 02 00  Icon640Table DC L:StopIcon640
0244 6AF0 F8 6D 02 00           DC L:NoteIcon640
0245 6AF4 D8 6E 02 00           DC L:CautionIcon640
0246 6AF8
0247 6AF8              ;   ENTRY  Icon_Template
0248 6AF8              ;Icon_Template  DC.W    -32768                  ; item ID
0249 6AF8              ;               DC.W    5,20,23,60              ; *** subject to change
0250 6AF8              ;               DC.W    IconItem+ItemDisable
0251 6AF8              ;               DC.L    IconHandleStruct        ; icon handle
0252 6AF8              ;               DC.W    0
0253 6AF8              ;               DC.W    0
0254 6AF8              ;               DC.L    0
0255 6AF8
0256 6AF8              ;
0257 6AF8              ; NoteIcon 320 (each bit * 4 to get the quickdraw bitmap)
0258 6AF8              ;
0259 6AF8
0260 6AF8                       entry NoteIcon640 
0261 6AF8                       entry CautionIcon640 
0262 6AF8                       entry StopIcon640 
0263 6AF8                       entry NoteIcon320 
0264 6AF8                       entry CautionIcon320 
0265 6AF8                       entry StopIcon320 
0266 6AF8
0267 6AF8 00 00 00 00  NoteIcon640 DC W:0,0,18,48
0268 6B00 00 00 00 00           DC B:$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
0269 6B0C 0F FF FF F0           DC B:$0F,$FF,$FF,$F0,$00,$00,$00,$00,$00,$00,$00,$00
0270 6B18 0F FF FF F0           DC B:$0F,$FF,$FF,$F0,$00,$00,$00,$00,$00,$00,$00,$00
0271 6B24 0F FF 0F F0           DC B:$0F,$FF,$0F,$F0,$00,$00,$ee,$ee,$ee,$e0,$00,$00
0272 6B30 0F FF 0F F0           DC B:$0F,$FF,$0F,$F0,$00,$0e,$ee,$ee,$ee,$ee,$00,$00
0273 6B3C 0F FF FF F0           DC B:$0F,$FF,$FF,$F0,$00,$ee,$ee,$ee,$ee,$ee,$e0,$00
0274 6B48 0F FF FF F0           DC B:$0F,$FF,$FF,$F0,$00,$ee,$00,$e0,$e0,$00,$e0,$00
0275 6B54 0F FF FF F0           DC B:$0F,$FF,$FF,$F0,$00,$ee,$ee,$ee,$ee,$ee,$e0,$00
0276 6B60 0F FF FF F0           DC B:$0F,$FF,$FF,$F0,$00,$ee,$0e,$0e,$00,$e0,$e0,$00
0277 6B6C 0F FF FF F0           DC B:$0F,$FF,$FF,$F0,$00,$ee,$ee,$ee,$ee,$ee,$e0,$00
0278 6B78 0F FF FF F0           DC B:$0F,$FF,$FF,$F0,$00,$ee,$00,$e0,$0e,$0e,$e0,$00
0279 6B84 0F FF 00 00           DC B:$0F,$FF,$00,$00,$00,$ee,$ee,$ee,$ee,$ee,$e0,$00
0280 6B90 0F FF FF 00           DC B:$0F,$FF,$FF,$00,$00,$ee,$ee,$ee,$ee,$ee,$00,$00
0281 6B9C 0F FF FF 00           DC B:$0F,$FF,$FF,$00,$0e,$ee,$ee,$ee,$ee,$e0,$00,$00
0282 6BA8 0F F0 00 0E           DC B:$0F,$F0,$00,$0e,$ee,$ee,$ee,$ee,$e0,$00,$00,$00
0283 6BB4 0F FF FF 00           DC B:$0F,$FF,$FF,$00,$00,$00,$00,$00,$00,$00,$00,$00
0284 6BC0 0F FF FF 00           DC B:$0F,$FF,$FF,$00,$00,$00,$00,$00,$00,$00,$00,$00
0285 6BCC 00 00 00 00           DC B:$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
0286 6BD8
0287 6BD8 00 00 00 00  CautionIcon640 DC W:0,0,18,40
0288 6BE0 FF FF FF FC           DC B:$FF,$FF,$FF,$FC,$00,$00,$3F,$FF,$FF,$FF
0289 6BEA FF FF FF C0           DC B:$FF,$FF,$FF,$C0,$00,$00,$03,$FF,$FF,$FF
0290 6BF4 FF FF FF 00           DC B:$FF,$FF,$FF,$00,$3E,$EC,$00,$FF,$FF,$FF
0291 6BFE FF FF FC 00           DC B:$FF,$FF,$FC,$00,$EE,$EE,$00,$3F,$FF,$FF
0292 6C08 FF FF F0 03           DC B:$FF,$FF,$F0,$03,$E0,$0E,$C0,$0F,$FF,$FF
0293 6C12 FF FF C0 0E           DC B:$FF,$FF,$C0,$0E,$C0,$03,$E0,$03,$FF,$FF
0294 6C1C FF FF 00 3E           DC B:$FF,$FF,$00,$3E,$C0,$03,$EC,$00,$FF,$FF
0295 6C26 FF FC 00 EE           DC B:$FF,$FC,$00,$EE,$C0,$03,$EE,$00,$3F,$FF
0296 6C30 FF F0 03 EE           DC B:$FF,$F0,$03,$EE,$C0,$03,$EE,$C0,$0F,$FF
0297 6C3A FF C0 0E EE           DC B:$FF,$C0,$0E,$EE,$E0,$0E,$EE,$E0,$03,$FF
0298 6C44 FF 00 3E EE           DC B:$FF,$00,$3E,$EE,$E0,$0E,$EE,$EC,$00,$FF
0299 6C4E FC 00 EE EE           DC B:$FC,$00,$EE,$EE,$EC,$3E,$EE,$EE,$00,$3F
0300 6C58 F0 03 EE EE           DC B:$F0,$03,$EE,$EE,$EE,$EE,$EE,$EE,$C0,$0F
0301 6C62 C0 0E EE EE           DC B:$C0,$0E,$EE,$EE,$E0,$0E,$EE,$EE,$E0,$03
0302 6C6C 00 3E EE EE           DC B:$00,$3E,$EE,$EE,$E0,$0E,$EE,$EE,$EC,$00
0303 6C76 00 EE EE EE           DC B:$00,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE,$00
0304 6C80 00 00 00 00           DC B:$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
0305 6C8A C0 00 00 00           DC B:$C0,$00,$00,$00,$00,$00,$00,$00,$00,$03
0306 6C94
0307 6C94
0308 6C94 00 00 00 00  StopIcon640 DC W:0,0,18,48
0309 6C9C FF FF FC 00           DC B:$FF,$FF,$FC,$00,$00,$00,$00,$00,$0F,$FF,$FF,$FF
0310 6CA8 FF FF C0 44           DC B:$FF,$FF,$C0,$44,$44,$44,$44,$44,$40,$FF,$FF,$FF
0311 6CB4 FF FC 04 44           DC B:$FF,$FC,$04,$44,$44,$40,$44,$44,$44,$0F,$FF,$FF
0312 6CC0 FF C0 44 44           DC B:$FF,$C0,$44,$44,$40,$0F,$00,$44,$44,$40,$FF,$FF
0313 6CCC FC 04 44 44           DC B:$FC,$04,$44,$44,$0F,$0F,$0F,$04,$44,$44,$0F,$FF
0314 6CD8 C0 44 44 40           DC B:$C0,$44,$44,$40,$0F,$0F,$0F,$04,$44,$44,$40,$FF
0315 6CE4 C0 44 44 0F           DC B:$C0,$44,$44,$0F,$0F,$0F,$0F,$04,$44,$44,$40,$FF
0316 6CF0 C0 44 44 0F           DC B:$C0,$44,$44,$0F,$0F,$0F,$0F,$04,$04,$44,$40,$FF
0317 6CFC C0 44 44 0F           DC B:$C0,$44,$44,$0F,$0F,$0F,$0F,$00,$F0,$44,$40,$FF
0318 6D08 C0 44 44 0F           DC B:$C0,$44,$44,$0F,$FF,$FF,$FF,$F0,$F0,$44,$40,$FF
0319 6D14 C0 44 44 0F           DC B:$C0,$44,$44,$0F,$FF,$FF,$00,$0F,$F0,$44,$40,$FF
0320 6D20 C0 44 44 0F           DC B:$C0,$44,$44,$0F,$FF,$F0,$FF,$FF,$04,$44,$40,$FF
0321 6D2C C0 44 44 0F           DC B:$C0,$44,$44,$0F,$FF,$FF,$FF,$F0,$44,$44,$40,$FF
0322 6D38 FC 04 44 40           DC B:$FC,$04,$44,$40,$FF,$FF,$FF,$04,$44,$44,$0F,$FF
0323 6D44 FF C0 44 44           DC B:$FF,$C0,$44,$44,$0F,$FF,$F0,$44,$44,$40,$FF,$FF
0324 6D50 FF FC 04 44           DC B:$FF,$FC,$04,$44,$44,$44,$44,$44,$44,$0F,$FF,$FF
0325 6D5C FF FF C0 44           DC B:$FF,$FF,$C0,$44,$44,$44,$44,$44,$40,$FF,$FF,$FF
0326 6D68 FF FF FC 00           DC B:$FF,$FF,$FC,$00,$00,$00,$00,$00,$0F,$FF,$FF,$FF
0327 6D74
0328 6D74 00 00 00 00  NoteIcon320 DC W:0,0,18,24
0329 6D7C 00 00 00 00           DC B:$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
0330 6D88 0F FF FF F0           DC B:$0F,$FF,$FF,$F0,$00,$00,$00,$00,$00,$00,$00,$00
0331 6D94 0F FF FF F0           DC B:$0F,$FF,$FF,$F0,$00,$00,$00,$00,$00,$00,$00,$00
0332 6DA0 0F FF 0F F0           DC B:$0F,$FF,$0F,$F0,$00,$00,$99,$99,$99,$90,$00,$00
0333 6DAC 0F FF 0F F0           DC B:$0F,$FF,$0F,$F0,$00,$09,$99,$99,$99,$99,$00,$00
0334 6DB8 0F FF FF F0           DC B:$0F,$FF,$FF,$F0,$00,$99,$99,$99,$99,$99,$90,$00
0335 6DC4 0F FF FF F0           DC B:$0F,$FF,$FF,$F0,$00,$99,$00,$90,$90,$00,$90,$00
0336 6DD0 0F FF FF F0           DC B:$0F,$FF,$FF,$F0,$00,$99,$99,$99,$99,$99,$90,$00
0337 6DDC 0F FF FF F0           DC B:$0F,$FF,$FF,$F0,$00,$99,$09,$09,$00,$90,$90,$00
0338 6DE8 0F FF FF F0           DC B:$0F,$FF,$FF,$F0,$00,$99,$99,$99,$99,$99,$90,$00
0339 6DF4 0F FF FF F0           DC B:$0F,$FF,$FF,$F0,$00,$99,$00,$90,$09,$09,$90,$00
0340 6E00 0F FF 00 00           DC B:$0F,$FF,$00,$00,$00,$99,$99,$99,$99,$99,$90,$00
0341 6E0C 0F FF FF 00           DC B:$0F,$FF,$FF,$00,$00,$99,$99,$99,$99,$99,$00,$00
0342 6E18 0F FF FF 00           DC B:$0F,$FF,$FF,$00,$09,$99,$99,$99,$99,$90,$00,$00
0343 6E24 0F F0 00 09           DC B:$0F,$F0,$00,$09,$99,$99,$99,$99,$90,$00,$00,$00
0344 6E30 0F FF FF 00           DC B:$0F,$FF,$FF,$00,$00,$00,$00,$00,$00,$00,$00,$00
0345 6E3C 0F FF FF 00           DC B:$0F,$FF,$FF,$00,$00,$00,$00,$00,$00,$00,$00,$00
0346 6E48 00 00 00 00           DC B:$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
0347 6E54
0348 6E54 00 00 00 00  CautionIcon320 DC W:0,0,18,20
0349 6E5C FF FF FF F1           DC B:$FF,$FF,$FF,$F1,$00,$00,$1F,$FF,$FF,$FF
0350 6E66 FF FF FF 10           DC B:$FF,$FF,$FF,$10,$00,$00,$01,$FF,$FF,$FF
0351 6E70 FF FF FF 00           DC B:$FF,$FF,$FF,$00,$19,$91,$00,$FF,$FF,$FF
0352 6E7A FF FF F1 00           DC B:$FF,$FF,$F1,$00,$99,$99,$00,$1F,$FF,$FF
0353 6E84 FF FF F0 01           DC B:$FF,$FF,$F0,$01,$90,$09,$10,$0F,$FF,$FF
0354 6E8E FF FF 10 09           DC B:$FF,$FF,$10,$09,$90,$09,$90,$01,$FF,$FF
0355 6E98 FF FF 00 19           DC B:$FF,$FF,$00,$19,$90,$09,$91,$00,$FF,$FF
0356 6EA2 FF F1 00 99           DC B:$FF,$F1,$00,$99,$90,$09,$99,$00,$1F,$FF
0357 6EAC FF F0 01 99           DC B:$FF,$F0,$01,$99,$90,$09,$99,$10,$0F,$FF
0358 6EB6 FF 10 09 99           DC B:$FF,$10,$09,$99,$90,$09,$99,$90,$01,$FF
0359 6EC0 FF 00 19 99           DC B:$FF,$00,$19,$99,$90,$09,$99,$91,$00,$FF
0360 6ECA F1 00 99 99           DC B:$F1,$00,$99,$99,$90,$09,$99,$99,$00,$1F
0361 6ED4 F0 01 99 99           DC B:$F0,$01,$99,$99,$99,$99,$99,$99,$10,$0F
0362 6EDE 10 09 99 99           DC B:$10,$09,$99,$99,$90,$09,$99,$99,$90,$01
0363 6EE8 00 19 99 99           DC B:$00,$19,$99,$99,$90,$09,$99,$99,$91,$00
0364 6EF2 00 99 99 99           DC B:$00,$99,$99,$99,$99,$99,$99,$99,$99,$00
0365 6EFC 00 00 00 00           DC B:$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
0366 6F06 F0 00 00 00           DC B:$F0,$00,$00,$00,$00,$00,$00,$00,$00,$0F
0367 6F10
0368 6F10 00 00 00 00  StopIcon320 DC W:0,0,18,24
0369 6F18 FF FF FF 00           DC B:$FF,$FF,$FF,$00,$00,$00,$00,$00,$0F,$FF,$FF,$FF
0370 6F24 FF FF F0 77           DC B:$FF,$FF,$F0,$77,$77,$77,$77,$77,$70,$FF,$FF,$FF
0371 6F30 FF FF 07 77           DC B:$FF,$FF,$07,$77,$77,$70,$77,$77,$77,$0F,$FF,$FF
0372 6F3C FF F0 77 77           DC B:$FF,$F0,$77,$77,$70,$0F,$00,$77,$77,$70,$FF,$FF
0373 6F48 FF 07 77 77           DC B:$FF,$07,$77,$77,$0F,$0F,$0F,$07,$77,$77,$0F,$FF
0374 6F54 F0 77 77 70           DC B:$F0,$77,$77,$70,$0F,$0F,$0F,$07,$77,$77,$70,$FF
0375 6F60 F0 77 77 0F           DC B:$F0,$77,$77,$0F,$0F,$0F,$0F,$07,$77,$77,$70,$FF
0376 6F6C F0 77 77 0F           DC B:$F0,$77,$77,$0F,$0F,$0F,$0F,$07,$07,$77,$70,$FF
0377 6F78 F0 77 77 0F           DC B:$F0,$77,$77,$0F,$0F,$0F,$0F,$00,$F0,$77,$70,$FF
0378 6F84 F0 77 77 0F           DC B:$F0,$77,$77,$0F,$FF,$FF,$FF,$F0,$F0,$77,$70,$FF
0379 6F90 F0 77 77 0F           DC B:$F0,$77,$77,$0F,$FF,$FF,$00,$0F,$F0,$77,$70,$FF
0380 6F9C F0 77 77 0F           DC B:$F0,$77,$77,$0F,$FF,$F0,$FF,$FF,$07,$77,$70,$FF
0381 6FA8 F0 77 77 0F           DC B:$F0,$77,$77,$0F,$FF,$FF,$FF,$F0,$77,$77,$70,$FF
0382 6FB4 FF 07 77 70           DC B:$FF,$07,$77,$70,$FF,$FF,$FF,$07,$77,$77,$0F,$FF
0383 6FC0 FF F0 77 77           DC B:$FF,$F0,$77,$77,$0F,$FF,$F0,$77,$77,$70,$FF,$FF
0384 6FCC FF FF 07 77           DC B:$FF,$FF,$07,$77,$77,$77,$77,$77,$77,$0F,$FF,$FF
0385 6FD8 FF FF F0 77           DC B:$FF,$FF,$F0,$77,$77,$77,$77,$77,$70,$FF,$FF,$FF
0386 6FE4 FF FF FF 00           DC B:$FF,$FF,$FF,$00,$00,$00,$00,$00,$0F,$FF,$FF,$FF
0387 6FF0
0388 6FF0                       ENDP 
0389 6FF0
0390 6FF0
0391 6FF0              ;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
0392 6FF0              ;
0393 6FF0              ;        quit2
0394 6FF0              ;
0395 6FF0              ;       input: A=error code
0396 6FF0              ;
0397 6FF0              ;      output: none
0398 6FF0              ;
0399 6FF0              ;    function: exit from a procedure with 2 bytes of input and adjust carry
0400 6FF0              ;
0401 6FF0              ;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
0402 6FF0
0403 6FF0                       ENTRY quit2 
0404 6FF0              quit2    PROC Export 
0405 6FF0              ;
0406 6FF0              ; Stack is: output, input, rtl1, rtl2, local space, previous D register
0407 6FF0              ;
0408 6FF0 20 05 73              jsr   disposelocals
0409 6FF3
0410 6FF3              ;
0411 6FF3              ; Stack is: output, input, rtl1, rtl2
0412 6FF3              ;
0413 6FF3
0414 6FF3              ;
0415 6FF3              ; Remove input parameters
0416 6FF3              ;
0417 6FF3 A3 05                 lda   5,s
0418 6FF5 83 07                 sta   7,s
0419 6FF7 A3 03                 lda   3,s
0420 6FF9 83 05                 sta   5,s
0421 6FFB A3 01                 lda   1,s
0422 6FFD 83 03                 sta   3,s
0423 6FFF 68                    pla                            ; add 2 to stack pointer
0424 7000
0425 7000 98                    tya                            ; adjust carry
0426 7001 C9 01 00              cmp   #1
0427 7004 6B                    rtl                            ; quit procedure
0428 7005                       ENDP 
0429 7005
0430 7005
0431 7005              ;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
0432 7005              ;
0433 7005              ;        disposelocals
0434 7005              ;
0435 7005              ;       input: X=size of local space
0436 7005              ;
0437 7005              ;      output: none
0438 7005              ;
0439 7005              ;    function: restore zero page, save error code, and remove local vars from
0440 7005              ;              stack.
0441 7005              ;
0442 7005              ;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
0443 7005
0444 7005                       ENTRY disposelocals 
0445 7005              disposelocals PROC 
0446 7005 A8                    tay                            ; save error code
0447 7006 68                    pla                            ; save return address
0448 7007 2B                    pld                            ; restore zero page
0449 7008
0450 7008 E0 00 00              cpx   #0
0451 700B F0 07                 beq   exit
0452 700D
0453 700D              ;
0454 700D              ; Remove local vars from stack
0455 700D              ;
0456 700D              nextbyte                                ;
0457 700D 83 01                 sta   1,s                      ; store return address on stack
0458 700F 68                    pla                            ; decrement stack and get return address
0459 7010 CA                    dex                            ; (that's a huge trick!)
0460 7011 CA                    dex   
0461 7012 D0 F9                 bne   nextbyte
0462 7014
0463 7014              exit                                    ;
0464 7014 48                    pha                            ; restore return address
0465 7015 60                    rts   
0466 7016                       ENDP 
0467 7016
0468 7016                       END   
